package com.fp.persistence.pgeneral.acco;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENESOLICITUDEFORDEBIT*/
@Entity(name="TgeneSolicitudeForDebit")
@Table(name="TGENESOLICITUDEFORDEBIT")
public class TgeneSolicitudeForDebit extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneSolicitudeForDebit
*/
@EmbeddedId
private TgeneSolicitudeForDebitKey pk;
@Column(name="DEBITACCOUNT", nullable=true)

/**
* Numero de cuenta a debitar cuando el cargo se cobra con debito a la cuenta.
*/
private String debitaccount;

@Column(name="DEBITACCOUNTINGCODE", nullable=true)

/**
* Codigo contable cuando el cargo se cobra con debito a la cuenta.
*/
private String debitaccountingcode;

@Column(name="CURRENCY", nullable=true)

/**
* Codigo de moneda de la cuenta de la operacion.
*/
private String currency;

@Column(name="VALUE", nullable=true)

/**
* Valor en la moneda de la cuenta, la compra venta se hace en funcion a la moneda de la cuenta debito
*/
private BigDecimal value;

/**Contructor por defecto*/
public TgeneSolicitudeForDebit(){
}
/**Contructor de TgeneSolicitudeForDebit
@param pPk Clave Primaria del entity
*/
public TgeneSolicitudeForDebit(TgeneSolicitudeForDebitKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneSolicitudeForDebit
*/
public static TgeneSolicitudeForDebit find(EntityManager pEntityManager,TgeneSolicitudeForDebitKey pKey) throws Exception{
    TgeneSolicitudeForDebit obj = pEntityManager.find(TgeneSolicitudeForDebit.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneSolicitudeForDebit
@return El objeto que referencia a la Clave primaria de TgeneSolicitudeForDebit
*/
public TgeneSolicitudeForDebitKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneSolicitudeForDebit
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneSolicitudeForDebit
*/
public void setPk(TgeneSolicitudeForDebitKey pPk){
  pk=pPk;
}
/**Obtiene el valor de debitaccount
@return valor de debitaccount*/
public String getDebitaccount(){
  return debitaccount;
}
/**Fija el valor de debitaccount
@param pDebitaccount nuevo Valor de debitaccount*/
public void setDebitaccount(String pDebitaccount){
  debitaccount=pDebitaccount;
}

/**Obtiene el valor de debitaccountingcode
@return valor de debitaccountingcode*/
public String getDebitaccountingcode(){
  return debitaccountingcode;
}
/**Fija el valor de debitaccountingcode
@param pDebitaccountingcode nuevo Valor de debitaccountingcode*/
public void setDebitaccountingcode(String pDebitaccountingcode){
  debitaccountingcode=pDebitaccountingcode;
}

/**Obtiene el valor de currency
@return valor de currency*/
public String getCurrency(){
  return currency;
}
/**Fija el valor de currency
@param pCurrency nuevo Valor de currency*/
public void setCurrency(String pCurrency){
  currency=pCurrency;
}

/**Obtiene el valor de value
@return valor de value*/
public BigDecimal getValue(){
  return value;
}
/**Fija el valor de value
@param pValue nuevo Valor de value*/
public void setValue(BigDecimal pValue){
  value=pValue;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneSolicitudeForDebit))return false;
    TgeneSolicitudeForDebit that = (TgeneSolicitudeForDebit) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneSolicitudeForDebit
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneSolicitudeForDebit
*/
public Object createInstance(){
 TgeneSolicitudeForDebit instance=new TgeneSolicitudeForDebit();	
 instance.setPk(new TgeneSolicitudeForDebitKey());
 return instance;
}
/**Clona la entidad TgeneSolicitudeForDebit
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneSolicitudeForDebit p=(TgeneSolicitudeForDebit)this.clone();
  p.setPk((TgeneSolicitudeForDebitKey)this.pk.cloneMe());
  return p;
}

	//Metodos manuales.
	/**Sentencia que devuelve uan lista con los valores de cuentas para debitos asociadas a una solicitud.*/
	private static final String HQL_SOLICITUDE_FORDEBIT =
	"from TgeneSolicitudeForDebit tsd  " +
	" where tsd.pk.solicitudnumber = :solicitudnumber "+
	" and tsd.pk.solicitudsequence = :solicitudsequence "+
	" order by tsd.pk.debitsequence ";

	/**
	 * Metodo que entrega una lista de valores a cobrar al cliente, en la aperturad e una operacion. 
	 * @param pSolicitudNumber		Numero de solicitud. 
	 * @param pSolicitudSequence	Secuencia dentro de la solicitud. 
	 * @return	List<TgeneSolicitudeForDebit>
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public static List<TgeneSolicitudeForDebit> find(EntityManager pEntityManager,
			String pSolicitudNumber,Integer pSolicitudSequence) throws Exception {
		List<TgeneSolicitudeForDebit>  lObjects = null;
		Query qry = pEntityManager.createQuery(HQL_SOLICITUDE_FORDEBIT);
		qry.setParameter("solicitudnumber", pSolicitudNumber);
		qry.setParameter("solicitudsequence", pSolicitudSequence);
		lObjects = qry.getResultList();	
		return lObjects;
	}

}
